#!/usr/bin/python
import os.path
import zmq
import signal
import sys

BASE_FILENAME = 'out'

# Functions
def sighandler(signum, frame):
  print 'Stopping now...'
  if os.path.isfile('.init_energy_measure'):
    os.remove('.init_energy_measure')
  if os.path.isfile('.stop_energy_measure'):
    os.remove('.stop_energy_measure')
  sys.exit(1)

def main():
  signal.signal(signal.SIGINT, sighandler)

  for i in range(0, int(sys.argv[1])):
    while not os.path.isfile('.init_energy_measure'):
      continue

    os.remove('.init_energy_measure')

    # TCP connexion
    context = zmq.Context()
    socket = context.socket(zmq.SUB)
    socket.connect("tcp://localhost:5214")
    socket.setsockopt(zmq.SUBSCRIBE, "")

    with open(BASE_FILENAME + str(i) + ".txt", 'w') as f:
      while not os.path.isfile('.stop_energy_measure'):
        data = socket.recv().split(" ")
        if len(data)>0:
          #print ' '.join(data[0:])
          data = ' '.join(data[0:])
          f.write(data + '\n')
 
    os.remove('.stop_energy_measure')

# Program
if __name__ == "__main__":
  main()
